varying vec4 pos;
uniform sampler2D tex;
uniform sampler2D texNormal;
uniform samplerCube Cubemap;

uniform vec4 lightspec1, lightspec2;
uniform vec4 l1_diff, l2_diff;

uniform mat3 inverseView;

varying mat3 tbnMatrix;

void main() {



	vec4 lpos1=gl_LightSource[1].position;
	vec4 lpos2=gl_LightSource[2].position;

	float dist1, dist2;
	vec4 color = texture2D(tex,gl_TexCoord[0].st);

	vec3 n=2.0*(texture2D(texNormal, gl_TexCoord[0].st).rgb-0.5);

	n.y=-n.y;

	n=normalize(gl_NormalMatrix*tbnMatrix*n);

	float att1, att2;

	vec4 view=normalize(-pos);

	float specularPower;

	//licht 1
	
	vec4 lvec1 = lpos1-pos; 
	dist1 = length(lvec1);


	vec4 specular1=vec4(0.0,0.0,0.0,1.0);
	vec4 diffuse1=vec4(0.0,0.0,0.0,1.0);

	vec4 matspec=vec4(0.1,0.1,0.1,1.0);
	float shininess=2.0;


	if (dist1<30.0) {
		lvec1=normalize(lvec1);
		vec4 shadowDepth = vec4(textureCube(Cubemap, inverseView*(-lvec1.xyz)));

		if ((dist1/30.0-0.0035)<shadowDepth.a) {

			vec3 halfV1=reflect(-lvec1.xyz, n);

			att1 = 1.0 / (1.0 +
				0.0* dist1 +
				0.1 * dist1 * dist1);

			diffuse1  = att1*color*l1_diff * max(0.0, dot(n, lvec1.xyz));
			diffuse1.a=1.0;

			specularPower=pow(max(0.0, dot(halfV1, view.xyz)), shininess);
			specular1=lightspec1*specularPower*att1*matspec;
		}
	}


	//licht 2
	vec4 lvec2 = normalize(lpos2-pos);

	vec3 halfV2=reflect(-lvec2.xyz, n);

	vec4 diffuse2  = color*vec4(0.2,0.2,0.2,1.0)+color*l2_diff * max(0.0, dot(n, lvec2.xyz));
	diffuse2.a=1.0;

	specularPower=pow(max(0.0, dot(halfV2, view.xyz)), shininess);
	vec4 specular2;
	specular2=lightspec2*specularPower*matspec;

	gl_FragColor = diffuse1+specular1+diffuse2+specular2;

	gl_FragColor.a=1.0;
}